diff --git a/include/ftw.h b/include/ftw.h
index 4fb654cf22..8fb89c4046 100644
--- a/include/ftw.h
+++ b/include/ftw.h
@@ -1 +1,19 @@
+#ifndef _FTW_H
 #include <io/ftw.h>
+
+#ifndef _ISOMAC
+# if __TIMESIZE != 64
+#  include <sys/stat.h>
+
+typedef int (*__ftw64_time64_func_t) (const char *,
+				      const struct __stat64_t64 *, int);
+typedef int (*__nftw64_time64_func_t) (const char *,
+				       const struct __stat64_t64 *, int,
+				       struct FTW *);
+
+extern int __ftw64_time64 (const char *, __ftw64_time64_func_t, int);
+extern int __nftw64_time64 (const char *, __nftw64_time64_func_t, int, int);
+# endif
+#endif
+
+#endif /* _FTW_H  */
diff --git a/io/Makefile b/io/Makefile
index f3a34854e1..6c637f7c6d 100644
--- a/io/Makefile
+++ b/io/Makefile
@@ -55,7 +55,8 @@ routines :=								\
 	posix_fallocate posix_fallocate64				\
 	sendfile sendfile64 copy_file_range 				\
 	utimensat futimens file_change_detection			\
-	fts64-time64
+	fts64-time64							\
+	ftw64-time64
 
 others		:= pwd
 test-srcs	:= ftwtest
@@ -100,6 +101,7 @@ CFLAGS-fts64.c += -Wno-uninitialized $(uses-callbacks) -fexceptions
 CFLAGS-fts64-time64.c += -Wno-uninitialized $(uses-callbacks) -fexceptions
 CFLAGS-ftw.c += $(uses-callbacks) -fexceptions
 CFLAGS-ftw64.c += $(uses-callbacks) -fexceptions
+CFLAGS-ftw64-time64.c += $(uses-callbacks) -fexceptions
 CFLAGS-posix_fallocate.c += -fexceptions
 CFLAGS-posix_fallocate64.c += -fexceptions
 CFLAGS-fallocate.c += -fexceptions
diff --git a/io/ftw.c b/io/ftw.c
index baca3deeee..ce1c6a14a3 100644
--- a/io/ftw.c
+++ b/io/ftw.c
@@ -821,7 +821,7 @@ FTW_NAME (const char *path, FTW_FUNC_T func, int descriptors)
   return ftw_startup (path, 0, func, descriptors, 0);
 }
 
-#ifndef _LIBC
+#ifndef NFTW_OLD_NAME
 int
 NFTW_NAME (const char *path, NFTW_FUNC_T func, int descriptors, int flags)
 {
@@ -844,7 +844,6 @@ NFTW_NEW_NAME (const char *path, NFTW_FUNC_T func, int descriptors, int flags)
     }
   return ftw_startup (path, 1, func, descriptors, flags);
 }
-
 versioned_symbol (libc, NFTW_NEW_NAME, NFTW_NAME, GLIBC_2_3_3);
 
 # if SHLIB_COMPAT(libc, GLIBC_2_1, GLIBC_2_3_3)
@@ -863,4 +862,4 @@ NFTW_OLD_NAME (const char *path, NFTW_FUNC_T func, int descriptors, int flags)
 
 compat_symbol (libc, NFTW_OLD_NAME, NFTW_NAME, GLIBC_2_1);
 # endif
-#endif
+#endif /* NFTW_OLD_NAME  */
diff --git a/io/ftw.h b/io/ftw.h
index 751d689cdb..446498856d 100644
--- a/io/ftw.h
+++ b/io/ftw.h
@@ -137,15 +137,36 @@ extern int ftw (const char *__dir, __ftw_func_t __func, int __descriptors)
      __nonnull ((1, 2));
 #else
 # ifdef __REDIRECT
+#  ifndef __USE_TIME_BITS64
 extern int __REDIRECT (ftw, (const char *__dir, __ftw_func_t __func,
 			     int __descriptors), ftw64) __nonnull ((1, 2));
+#  else
+extern int __REDIRECT (ftw, (const char *__dir, __ftw_func_t __func,
+			     int __descriptors), __ftw64_time64)
+     __nonnull ((1, 2));
+#  endif
 # else
-#  define ftw ftw64
+#  ifndef __USE_TIME_BITS64
+#   define ftw ftw64
+#  else
+#   define ftw __ftw64_time64
+#  endif
 # endif
 #endif
 #ifdef __USE_LARGEFILE64
+# ifndef __USE_TIME_BITS64
 extern int ftw64 (const char *__dir, __ftw64_func_t __func,
 		  int __descriptors) __nonnull ((1, 2));
+# else
+#  ifdef __REDIRECT
+extern int __REDIRECT (ftw64, (const char *__dir, __ftw64_func_t __func,
+			       int __descriptors),
+		       __ftw64_time64)
+     __nonnull ((1, 2));
+#  else
+#   define nftw64 __nftw64_time64
+#  endif
+# endif
 #endif
 
 #ifdef __USE_XOPEN_EXTENDED
@@ -159,16 +180,37 @@ extern int nftw (const char *__dir, __nftw_func_t __func, int __descriptors,
 		 int __flag) __nonnull ((1, 2));
 # else
 #  ifdef __REDIRECT
+#   ifndef __USE_TIME_BITS64
 extern int __REDIRECT (nftw, (const char *__dir, __nftw_func_t __func,
 			      int __descriptors, int __flag), nftw64)
      __nonnull ((1, 2));
+#   else
+extern int __REDIRECT (nftw, (const char *__dir, __nftw_func_t __func,
+			      int __descriptors, int __flag), __nftw64_time64)
+     __nonnull ((1, 2));
+#   endif
 #  else
-#   define nftw nftw64
+#   ifndef __USE_TIME_BITS64
+#    define nftw nftw64
+#   else
+#    define nftw __nftw64_time64
+#   endif
 #  endif
 # endif
 # ifdef __USE_LARGEFILE64
+#  ifndef __USE_TIME_BITS64
 extern int nftw64 (const char *__dir, __nftw64_func_t __func,
 		   int __descriptors, int __flag) __nonnull ((1, 2));
+#  else
+#   ifdef __REDIRECT
+extern int __REDIRECT (nftw64, (const char *__dir, __nftw64_func_t __func,
+				int __descriptors, int __flag),
+		       __nftw64_time64)
+     __nonnull ((1, 2));
+#   else
+#    define nftw64 __nftw64_time64
+#   endif
+#  endif
 # endif
 #endif
 
diff --git a/io/ftw64-time64.c b/io/ftw64-time64.c
new file mode 100644
index 0000000000..7c9db5448a
--- /dev/null
+++ b/io/ftw64-time64.c
@@ -0,0 +1,34 @@
+/* File tree walker functions.  LFS version.
+   Copyright (C) 1996-2021 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+   Contributed by Ulrich Drepper <drepper@cygnus.com>, 1996.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#include <sys/types.h>
+
+#if __TIMESIZE != 64
+# define FTW_NAME       __ftw64_time64
+# define NFTW_NAME      __nftw64_time64
+# define INO_T          ino64_t
+# define STRUCT_STAT    __stat64_t64
+# define LSTAT          __lstat64_time64
+# define STAT           __stat64_time64
+# define FSTATAT        __fstatat64_time64
+# define FTW_FUNC_T     __ftw64_time64_func_t
+# define NFTW_FUNC_T    __nftw64_time64_func_t
+
+# include "ftw.c"
+#endif
diff --git a/sysdeps/unix/sysv/linux/Versions b/sysdeps/unix/sysv/linux/Versions
index ba5216e928..b53391f613 100644
--- a/sysdeps/unix/sysv/linux/Versions
+++ b/sysdeps/unix/sysv/linux/Versions
@@ -185,6 +185,8 @@ libc {
     __fts64_read_time64;
     __fts64_set_time64;
     __fts64_children_time64;
+    __ftw64_time64;
+    __nftw64_time64;
     # misc
     __futimes64;
     __futimesat64;
diff --git a/sysdeps/unix/sysv/linux/arm/be/libc.abilist b/sysdeps/unix/sysv/linux/arm/be/libc.abilist
index 4034576f83..a34bca151d 100644
--- a/sysdeps/unix/sysv/linux/arm/be/libc.abilist
+++ b/sysdeps/unix/sysv/linux/arm/be/libc.abilist
@@ -172,6 +172,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -190,6 +191,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/arm/le/libc.abilist b/sysdeps/unix/sysv/linux/arm/le/libc.abilist
index 655035d9b0..5a7c57afa7 100644
--- a/sysdeps/unix/sysv/linux/arm/le/libc.abilist
+++ b/sysdeps/unix/sysv/linux/arm/le/libc.abilist
@@ -169,6 +169,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -187,6 +188,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/csky/libc.abilist b/sysdeps/unix/sysv/linux/csky/libc.abilist
index 51825b5516..c8b1890033 100644
--- a/sysdeps/unix/sysv/linux/csky/libc.abilist
+++ b/sysdeps/unix/sysv/linux/csky/libc.abilist
@@ -2132,6 +2132,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2150,6 +2151,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/hppa/libc.abilist b/sysdeps/unix/sysv/linux/hppa/libc.abilist
index 8523f451f2..5eb997849b 100644
--- a/sysdeps/unix/sysv/linux/hppa/libc.abilist
+++ b/sysdeps/unix/sysv/linux/hppa/libc.abilist
@@ -2091,6 +2091,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2109,6 +2110,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/i386/libc.abilist b/sysdeps/unix/sysv/linux/i386/libc.abilist
index b85302318c..3549788a52 100644
--- a/sysdeps/unix/sysv/linux/i386/libc.abilist
+++ b/sysdeps/unix/sysv/linux/i386/libc.abilist
@@ -2258,6 +2258,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2276,6 +2277,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist b/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
index eb9d2a23fe..f6b1b06ce9 100644
--- a/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/coldfire/libc.abilist
@@ -173,6 +173,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -191,6 +192,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist b/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
index 496c57a039..2f92eae937 100644
--- a/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
+++ b/sysdeps/unix/sysv/linux/m68k/m680x0/libc.abilist
@@ -2203,6 +2203,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2221,6 +2222,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/microblaze/be/libc.abilist b/sysdeps/unix/sysv/linux/microblaze/be/libc.abilist
index 7216a031eb..ae86eed8d0 100644
--- a/sysdeps/unix/sysv/linux/microblaze/be/libc.abilist
+++ b/sysdeps/unix/sysv/linux/microblaze/be/libc.abilist
@@ -2183,6 +2183,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2201,6 +2202,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/microblaze/le/libc.abilist b/sysdeps/unix/sysv/linux/microblaze/le/libc.abilist
index 6e1b8ff3a7..9f6b846a71 100644
--- a/sysdeps/unix/sysv/linux/microblaze/le/libc.abilist
+++ b/sysdeps/unix/sysv/linux/microblaze/le/libc.abilist
@@ -2180,6 +2180,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2198,6 +2199,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist b/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
index 89e3621708..c16000604b 100644
--- a/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips32/fpu/libc.abilist
@@ -2174,6 +2174,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2192,6 +2193,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist b/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
index 1080cc8332..76b864f9d2 100644
--- a/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips32/nofpu/libc.abilist
@@ -2172,6 +2172,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2190,6 +2191,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist b/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
index 98b2fc62f3..a20fb835e4 100644
--- a/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/mips/mips64/n32/libc.abilist
@@ -2180,6 +2180,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2198,6 +2199,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/nios2/libc.abilist b/sysdeps/unix/sysv/linux/nios2/libc.abilist
index f5140aec1e..a8b7a8c92c 100644
--- a/sysdeps/unix/sysv/linux/nios2/libc.abilist
+++ b/sysdeps/unix/sysv/linux/nios2/libc.abilist
@@ -2221,6 +2221,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2239,6 +2240,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
index 57daf51b4e..d5ab432dc3 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc32/fpu/libc.abilist
@@ -2230,6 +2230,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2248,6 +2249,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist b/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
index fae83acd3b..7885585950 100644
--- a/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
+++ b/sysdeps/unix/sysv/linux/powerpc/powerpc32/nofpu/libc.abilist
@@ -2263,6 +2263,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2281,6 +2282,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist b/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
index 47c86f2b03..de75dc4ac8 100644
--- a/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/s390/s390-32/libc.abilist
@@ -2228,6 +2228,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2246,6 +2247,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/sh/be/libc.abilist b/sysdeps/unix/sysv/linux/sh/be/libc.abilist
index 9d60db0845..573c2fcbbf 100644
--- a/sysdeps/unix/sysv/linux/sh/be/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sh/be/libc.abilist
@@ -2098,6 +2098,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2116,6 +2117,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/sh/le/libc.abilist b/sysdeps/unix/sysv/linux/sh/le/libc.abilist
index 5d6a69b751..ef942ed276 100644
--- a/sysdeps/unix/sysv/linux/sh/le/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sh/le/libc.abilist
@@ -2095,6 +2095,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2113,6 +2114,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F
diff --git a/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist b/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
index c787962323..802a2eb7ce 100644
--- a/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
+++ b/sysdeps/unix/sysv/linux/sparc/sparc32/libc.abilist
@@ -2219,6 +2219,7 @@ GLIBC_2.34 __fts64_close_time64 F
 GLIBC_2.34 __fts64_open_time64 F
 GLIBC_2.34 __fts64_read_time64 F
 GLIBC_2.34 __fts64_set_time64 F
+GLIBC_2.34 __ftw64_time64 F
 GLIBC_2.34 __futimens64 F
 GLIBC_2.34 __futimes64 F
 GLIBC_2.34 __futimesat64 F
@@ -2237,6 +2238,7 @@ GLIBC_2.34 __lutimes64 F
 GLIBC_2.34 __mktime64 F
 GLIBC_2.34 __msgctl64 F
 GLIBC_2.34 __nanosleep64 F
+GLIBC_2.34 __nftw64_time64 F
 GLIBC_2.34 __ntp_gettime64 F
 GLIBC_2.34 __ntp_gettimex64 F
 GLIBC_2.34 __ppoll64 F