diff --git a/include/sys/stat.h b/include/sys/stat.h
index b4c9344628..13e777b3c7 100644
--- a/include/sys/stat.h
+++ b/include/sys/stat.h
@@ -46,7 +46,7 @@ hidden_proto (__lstat64)
 hidden_proto (__fstatat64)
 # endif
 
-# if __TIMESIZE == 64
+# if __TIMESIZE == 64 || defined NO_RTLD_HIDDEN
 #  define __stat64_time64  __stat64
 #  define __fstat64_time64  __fstat64
 #  define __lstat64_time64  __lstat64
diff --git a/include/time.h b/include/time.h
index 4372bfbd96..980c6bd924 100644
--- a/include/time.h
+++ b/include/time.h
@@ -283,8 +283,8 @@ hidden_proto (__nanosleep64)
 #endif
 
 
-extern int __getdate_r (const char *__string, struct tm *__resbufp)
-  attribute_hidden;
+extern int __getdate_r (const char *__string, struct tm *__resbufp);
+libc_hidden_proto (__getdate_r);
 
 
 /* Determine CLK_TCK value.  */
@@ -509,6 +509,14 @@ time_now (void)
   return ts.tv_sec;
 }
 
+static inline __time64_t
+time64_now (void)
+{
+  struct __timespec64 ts;
+  __clock_gettime64 (TIME_CLOCK_GETTIME_CLOCKID, &ts);
+  return ts.tv_sec;
+}
+
 #define NSEC_PER_SEC    1000000000L  /* Nanoseconds per second.  */
 #define USEC_PER_SEC    1000000L     /* Microseconds per second.  */
 #define NSEC_PER_USEC   1000L        /* Nanoseconds per microsecond.  */
diff --git a/time/getdate.c b/time/getdate.c
index 6e2f75566b..cdcc898517 100644
--- a/time/getdate.c
+++ b/time/getdate.c
@@ -112,16 +112,16 @@ __getdate_r (const char *string, struct tm *tp)
   size_t len;
   char *datemsk;
   char *result = NULL;
-  time_t timer;
+  __time64_t timer;
   struct tm tm;
-  struct stat64 st;
-  int mday_ok = 0;
+  struct __stat64_t64 st;
+  bool mday_ok = false;
 
   datemsk = getenv ("DATEMSK");
   if (datemsk == NULL || *datemsk == '\0')
     return 1;
 
-  if (__stat64 (datemsk, &st) < 0)
+  if (__stat64_time64 (datemsk, &st) < 0)
     return 3;
 
   if (!S_ISREG (st.st_mode))
@@ -219,8 +219,8 @@ __getdate_r (const char *string, struct tm *tp)
     return 7;
 
   /* Get current time.  */
-  timer = time_now ();
-  __localtime_r (&timer, &tm);
+  timer = time64_now ();
+  __localtime64_r (&timer, &tm);
 
   /* If only the weekday is given, today is assumed if the given day
      is equal to the current day and next week if it is less.  */
@@ -230,7 +230,7 @@ __getdate_r (const char *string, struct tm *tp)
       tp->tm_year = tm.tm_year;
       tp->tm_mon = tm.tm_mon;
       tp->tm_mday = tm.tm_mday + (tp->tm_wday - tm.tm_wday + 7) % 7;
-      mday_ok = 1;
+      mday_ok = true;
     }
 
   /* If only the month is given, the current month is assumed if the
@@ -242,7 +242,7 @@ __getdate_r (const char *string, struct tm *tp)
       if (tp->tm_year == INT_MIN)
 	tp->tm_year = tm.tm_year + (((tp->tm_mon - tm.tm_mon) < 0) ? 1 : 0);
       tp->tm_mday = first_wday (tp->tm_year, tp->tm_mon, tp->tm_wday);
-      mday_ok = 1;
+      mday_ok = true;
     }
 
   /* If no hour, minute and second are given the current hour, minute
@@ -285,15 +285,13 @@ __getdate_r (const char *string, struct tm *tp)
      call normalizes the struct tm.  */
   if ((!mday_ok && !check_mday (TM_YEAR_BASE + tp->tm_year, tp->tm_mon,
 				tp->tm_mday))
-      || mktime (tp) == (time_t) -1)
+      || __mktime64 (tp) == (time_t) -1)
     return 8;
 
   return 0;
 }
-#ifdef weak_alias
 weak_alias (__getdate_r, getdate_r)
-#endif
-
+libc_hidden_def (__getdate_r)
 
 struct tm *
 getdate (const char *string)
diff --git a/time/tst-getdate.c b/time/tst-getdate.c
index c37ba3083a..3bb0e96707 100644
--- a/time/tst-getdate.c
+++ b/time/tst-getdate.c
@@ -115,20 +115,14 @@ do_test (void)
     {
       setenv ("TZ", tests[i].tz, 1);
 
-      int expected_err;
-      if (sizeof (time_t) == 4 && tests[i].time64)
-	expected_err = 8;
-      else
-	expected_err = 0;
-
       tm = getdate (tests[i].str);
-      TEST_COMPARE (getdate_err, expected_err);
-      if (getdate_err != expected_err)
+      TEST_COMPARE (getdate_err, 0);
+      if (getdate_err != 0)
 	{
 	  support_record_failure ();
 	  printf ("%s\n", report_date_error ());
 	}
-      else if (getdate_err == 0)
+      else
 	{
 	  TEST_COMPARE (tests[i].tm.tm_mon, tm->tm_mon);
 	  TEST_COMPARE (tests[i].tm.tm_year, tm->tm_year);
@@ -139,7 +133,7 @@ do_test (void)
 	}
 
       struct tm tms;
-      TEST_COMPARE (getdate_r (tests[i].str, &tms), expected_err);
+      TEST_COMPARE (getdate_r (tests[i].str, &tms), 0);
       if (getdate_err == 0)
 	{
 	  TEST_COMPARE (tests[i].tm.tm_mon, tms.tm_mon);